program Tracking;

{$APPTYPE CONSOLE}

uses
  Windows, Variants, Classes, StdCtrls, ExtCtrls, SysUtils,Graphics,jpeg;
//  Windows, Classes, StdCtrls, ExtCtrls, SysUtils,Graphics,jpeg,Matrix;
const max = 5;
type
  TDynMatrix = array of array of extended;
  TColorPoint = record
        r,g,b : integer;
  end;
  TColorPointReal = record
        r,g,b : extended;
  end;
  TRealPoint = record
        x,y : extended;
  end;

var
  i,j,i2,j2 : integer;
  tempResultX, tempResultY : integer;
  BitMapLeft, BitMapRight, DiffBitMap, SpecialPtBitMap : TBitMap;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     //   ,   
  dataDir, PathToFiles, FileName : string;                             //   
  LMatrixR, LMatrixG, LMatrixB,
   RMatrixR, RMatrixG, RMatrixB : array[0..max] of TDynMatrix;//       1  Lmax
  ImLeftL,ImRightL : TDynMatrix;      //     
  ImR, ImG, ImB : TDynMatrix;        //     
  dxMatrixR, dxMatrixG, dxMatrixB,
   dyMatrixR, dyMatrixG, dyMatrixB : array[0..max] of TDynMatrix;//    
  nx, ny : array [0..max] of integer;           //      
  wx, wy, realWx, realWy : integer;                              //     
  Lmax   : integer;                        //   
  guess, uL, v, d, MismatchVector : TRealPoint; //     
  pxl : TColor;
  newColor, diffColor : TColorPoint;
  extL, intL, l, deg : integer;                 //     
  G : array[1..2,1..2] of extended;             //  
  inverseG : array[1..2,1..2] of extended;      //    
  determinant : real;                           //   G   
  features,false_features : TextFile;    //  
  Str, strX, strY : string;
  i0, j0, i1, j1 : extended;   //    .   x   y
  i0R,i0G,i0B,i1R,i1G,i1B : extended;
  EigenValues1,EigenValues2 : TDynMatrix;
          // .       
  U : array of array of boolean;
  IsGoodToTrack : boolean;           //     "" 
  PointIsLost : boolean;
  intPartX, intPartY : integer;
  fracPartX, fracPartY : extended;
  FeaturesQuant, False_FeaturesQuant,Lost_FeaturesQuant : integer; //      
  DiffSum : extended;      //      
  NMax : real;
  MaxEigenValue : real;              //   .  
{----------------     ---------------}
procedure ReadParameters;
var
  F: TextFile;
begin
 dataDir:=GetCurrentDir;
 AssignFile(F,dataDir+'\Parameters.txt');
 Reset(F);
 while not EOF(F) do
 begin
   Readln(F, Str);
   if pos('//',str)=0 then        //   
   begin
     i:=pos('',Str);
     if i>0 then begin
                   Readln(F, Str);
                   PathToFiles:=str;
                 end;
     i:=pos('',Str);
     if i>0 then begin
                   Readln(F, Str);
                   FileName:=str;
                 end;
     i:=pos('',Str);
     if i>0 then begin
                   Readln(F, Str);
                   Lmax:=StrToInt(str);
                 end;
     i:=pos('1/2 ',Str);
     if i>0 then begin
                   Readln(F, Str);
                   wx:=StrToInt(str);
                 end;
     i:=pos('1/2 ',Str);
     if i>0 then begin
                   Readln(F, Str);
                   wy:=StrToInt(str);
                 end;
     i:=pos('Nmax',Str);
     if i>0 then begin
                   Readln(F, Str);
                   Nmax:=StrToInt(str);
                 end;

   end;
 end;
end;
{-------------------   b, g, r------------------------------------}
function DecomposeColor(f : TColor):TColorPoint;
var
  Col : TColorPoint;
begin
  Col.b:=f mod 256;
  f:=round((f-Col.b)) div 256;
  Col.g:=f mod 256;
  Col.r:=round((f-Col.g)) div 256;
  DecomposeColor:=Col;
end;

{----------------      L-------------}
procedure CalculateLDegree(MatrixType : string; degree : word);
var ix,iy : integer;
    ImR0,ImG0,ImB0,ImR1,ImG1,ImB1 : TDynMatrix;
begin
 SetLength(ImR0,nx[degree]+2,ny[degree]+2);
 SetLength(ImG0,nx[degree]+2,ny[degree]+2);
 SetLength(ImB0,nx[degree]+2,ny[degree]+2);
 SetLength(ImR1,nx[degree+1]+2,ny[degree+1]+2);
 SetLength(ImG1,nx[degree+1]+2,ny[degree+1]+2);
 SetLength(ImB1,nx[degree+1]+2,ny[degree+1]+2);
 if MatrixType='left' then begin
                             ImR0:=LMatrixR[degree];
                             ImG0:=LMatrixG[degree];
                             ImB0:=LMatrixB[degree];
                           end
  else begin
         ImR0:=RMatrixR[degree];
         ImB0:=RMatrixB[degree];
         ImG0:=RMatrixG[degree];
       end;
 for ix:=1 to nx[degree+1] do
 begin
   for iy:=1 to ny[degree+1] do
   begin
     ImR1[ix,iy]:=(ImR0[2*ix,2*iy])/4+(ImR0[2*ix-1,2*iy]+ImR0[2*ix+1,2*iy]
      +ImR0[2*ix,2*iy-1]+ImR0[2*ix,2*iy+1])/8+(ImR0[2*ix-1,2*iy-1]+ImR0[2*ix+1,2*iy+1]
       +ImR0[2*ix-1,2*iy+1]+ImR0[2*ix+1,2*iy-1])/16;
     ImB1[ix,iy]:=(ImB0[2*ix,2*iy])/4+(ImB0[2*ix-1,2*iy]+ImB0[2*ix+1,2*iy]
      +ImB0[2*ix,2*iy-1]+ImB0[2*ix,2*iy+1])/8+(ImB0[2*ix-1,2*iy-1]+ImB0[2*ix+1,2*iy+1]
       +ImB0[2*ix-1,2*iy+1]+ImB0[2*ix+1,2*iy-1])/16;
     ImG1[ix,iy]:=(ImG0[2*ix,2*iy])/4+(ImG0[2*ix-1,2*iy]+ImG0[2*ix+1,2*iy]
      +ImG0[2*ix,2*iy-1]+ImG0[2*ix,2*iy+1])/8+(ImG0[2*ix-1,2*iy-1]+ImG0[2*ix+1,2*iy+1]
       +ImG0[2*ix-1,2*iy+1]+ImG0[2*ix+1,2*iy-1])/16;

     if ix=1 then begin
                    ImR1[0,iy]:=ImR1[1,iy];
                    ImG1[0,iy]:=ImG1[1,iy];
                    ImB1[0,iy]:=ImB1[1,iy];
                  end;
     if ix=nx[degree+1] then
     begin
       ImR1[nx[degree+1]+1,iy]:=ImR1[nx[degree+1],iy];
       ImG1[nx[degree+1]+1,iy]:=ImG1[nx[degree+1],iy];
       ImB1[nx[degree+1]+1,iy]:=ImB1[nx[degree+1],iy];
     end;
   end;
   ImR1[ix,0]:=ImR1[ix,1];
   ImR1[ix,ny[degree+1]+1]:=ImR1[ix,ny[degree+1]];
   ImG1[ix,0]:=ImG1[ix,1];
   ImG1[ix,ny[degree+1]+1]:=ImG1[ix,ny[degree+1]];
   ImB1[ix,0]:=ImB1[ix,1];
   ImB1[ix,ny[degree+1]+1]:=ImB1[ix,ny[degree+1]];
 end;
 if MatrixType='left' then begin
                             LMatrixR[degree+1]:=ImR1;
                             LMatrixG[degree+1]:=ImG1;
                             LMatrixB[degree+1]:=ImB1;
                           end
                      else begin
                             RMatrixR[degree+1]:=ImR1;
                             RMatrixG[degree+1]:=ImG1;
                             RMatrixB[degree+1]:=ImB1;
                           end;
end;

{----------------    --------------}
procedure CalculateDerivatives;
var l, tempL :integer;
begin
  tempL:=1;
  for l:=0 to Lmax do
  begin
    SetLength(dxMatrixR[l],nx[0]+1,ny[0]+1);
    SetLength(dxMatrixG[l],nx[0]+1,ny[0]+1);
    SetLength(dxMatrixB[l],nx[0]+1,ny[0]+1);
    SetLength(dyMatrixR[l],nx[0]+1,ny[0]+1);
    SetLength(dyMatrixG[l],nx[0]+1,ny[0]+1);
    SetLength(dyMatrixB[l],nx[0]+1,ny[0]+1);
    for i:=1 to nx[0] do
    begin
      for j:=1 to ny[0] do
      begin
        if l=0 then
        begin
          dxMatrixR[l][i,j]:=(LMatrixR[l][i+1,j]-LMatrixR[l][i-1,j])/2;
          dxMatrixG[l][i,j]:=(LMatrixG[l][i+1,j]-LMatrixG[l][i-1,j])/2;
          dxMatrixB[l][i,j]:=(LMatrixB[l][i+1,j]-LMatrixB[l][i-1,j])/2;
          dyMatrixR[l][i,j]:=(LMatrixR[l][i,j+1]-LMatrixR[l][i,j-1])/2;
          dyMatrixG[l][i,j]:=(LMatrixG[l][i,j+1]-LMatrixG[l][i,j-1])/2;
          dyMatrixB[l][i,j]:=(LMatrixB[l][i,j+1]-LMatrixB[l][i,j-1])/2;
        end
        else
        begin
          intPartX:=trunc((i-1)/tempL);
          intPartY:=trunc(j/tempL);
          fracPartX:=(i-1)/tempL-intPartX;
          fracPartY:=j/tempL-intPartY;
          i0R:=(1-fracPartX)*(1-fracPartY)*LMatrixR[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixR[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixR[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixR[l][intPartX+1,intPartY+1];
          i0G:=(1-fracPartX)*(1-fracPartY)*LMatrixG[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixG[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixG[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixG[l][intPartX+1,intPartY+1];
          i0B:=(1-fracPartX)*(1-fracPartY)*LMatrixB[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixB[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixB[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixB[l][intPartX+1,intPartY+1];

          intPartX:=trunc((i+1)/tempL);
          intPartY:=trunc(j/tempL);
          fracPartX:=(i+1)/tempL-intPartX;
          fracPartY:=j/tempL-intPartY;
          i1R:=(1-fracPartX)*(1-fracPartY)*LMatrixR[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixR[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixR[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixR[l][intPartX+1,intPartY+1];
          i1G:=(1-fracPartX)*(1-fracPartY)*LMatrixG[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixG[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixG[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixG[l][intPartX+1,intPartY+1];
          i1B:=(1-fracPartX)*(1-fracPartY)*LMatrixB[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixB[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixB[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixB[l][intPartX+1,intPartY+1];
          dxMatrixR[l][i,j]:=(i1R-i0R)/2;
          dxMatrixG[l][i,j]:=(i1G-i0G)/2;
          dxMatrixB[l][i,j]:=(i1B-i0B)/2;
       
          intPartX:=trunc(i/tempL);
          intPartY:=trunc((j-1)/tempL);
          fracPartX:=i/tempL-intPartX;
          fracPartY:=(j-1)/tempL-intPartY;
          i0R:=(1-fracPartX)*(1-fracPartY)*LMatrixR[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixR[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixR[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixR[l][intPartX+1,intPartY+1];
          i0G:=(1-fracPartX)*(1-fracPartY)*LMatrixG[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixG[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixG[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixG[l][intPartX+1,intPartY+1];
          i0B:=(1-fracPartX)*(1-fracPartY)*LMatrixB[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixB[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixB[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixB[l][intPartX+1,intPartY+1];

          intPartX:=trunc(i/tempL);
          intPartY:=trunc((j+1)/tempL);
          fracPartX:=i/tempL-intPartX;
          fracPartY:=(j+1)/tempL-intPartY;
          i1R:=(1-fracPartX)*(1-fracPartY)*LMatrixR[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixR[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixR[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixR[l][intPartX+1,intPartY+1];
          i1G:=(1-fracPartX)*(1-fracPartY)*LMatrixG[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixG[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixG[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixG[l][intPartX+1,intPartY+1];
          i1B:=(1-fracPartX)*(1-fracPartY)*LMatrixB[l][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixB[l][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixB[l][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixB[l][intPartX+1,intPartY+1];
          dyMatrixR[l][i,j]:=(i1R-i0R)/2;
          dyMatrixG[l][i,j]:=(i1G-i0G)/2;
          dyMatrixB[l][i,j]:=(i1B-i0B)/2;
        end;
      end;   // j
    end;   // i
    tempL:=tempL*2;
  end;    // l
end;

{--        L-   --
       px-wx  px+wx }

Procedure CalcBoundaries(PosX,PosY: extended);
begin
//       px-wx  px+wx
  if PosX-wx>=0 then begin
                      realWx:=wx;
                      i0:=PosX-wx;
                     end
                     else begin
                           i0:=PosX-trunc(PosX); //    x
                           realWx:=abs(trunc(i0-PosX));
                          end;
  if PosY-wy>=0 then begin
                       j0:=PosY-wy;
                       realWy:=wy;
                     end
                     else begin
                            j0:=PosY-trunc(PosY); //    y
                            realWy:=abs(trunc(j0-PosY));
                          end;
  if PosX+wx<=nx[extL] then i1:=PosX+wx else i1:=nx[extL]-1+(PosX+wx-trunc(PosX+wx)); //    x
  if PosY+wy<=ny[extL] then j1:=PosY+wy else j1:=ny[extL]-1+(PosY+wy-trunc(PosY+wy)); //    y
end;

{-------------------  --------------------------------}
procedure BuildGradientMatrix(PosX,PosY : real);
var ix,iy : extended;
    px,py : integer;
begin
  G[1,1]:=0;
  G[1,2]:=0;
  G[2,1]:=0;
  G[2,2]:=0;
  ix:=i0;
  if extL>0 then px:=i-realWx*deg else px:=i-realWx;
  repeat
    iy:=j0;
    if extL>0 then py:=j-realWy*deg else py:=j-realWy;
    repeat
      G[1,1]:=G[1,1]+dxMatrixR[extL][px,py]*dxMatrixR[extL][px,py]+
          dxMatrixG[extL][px,py]*dxMatrixG[extL][px,py]+dxMatrixB[extL][px,py]*dxMatrixB[extL][px,py];
      G[1,2]:=G[1,2]+dxMatrixR[extL][px,py]*dyMatrixR[extL][px,py]+
           dxMatrixG[extL][px,py]*dyMatrixG[extL][px,py]+dxMatrixB[extL][px,py]*dyMatrixB[extL][px,py];
      G[2,1]:=G[1,2];
      G[2,2]:=G[2,2]+dyMatrixR[extL][px,py]*dyMatrixR[extL][px,py]+
          dyMatrixG[extL][px,py]*dyMatrixG[extL][px,py]+dyMatrixB[extL][px,py]*dyMatrixB[extL][px,py];
      iy:=iy+1;
      if extL>0 then py:=py+deg else py:=py+1;
    until iy>=j1;
    ix:=ix+1;
    if extL>0 then px:=px+deg else px:=px+1;
  until ix>=i1;
end;
{-------------      --------------------}
procedure BuildImageMismatchVector(PosX,PosY : real);
var ix,iy : extended;
    deltaIr, deltaIg, deltaIb : extended;
    px,py : integer;
    ImageJR, ImageJG,ImageJB : extended;
begin
  MismatchVector.x:=0;
  MismatchVector.y:=0;
  ix:=i0;
  if extL>0 then px:=i-realWx*deg else px:=i-realWx;
  repeat
    iy:=j0;
    if extL>0 then py:=j-realWy*deg else py:=j-realWy;
    repeat
   //        
      intPartX:=trunc(ix+guess.x+v.x);
      intPartY:=trunc(iy+guess.y+v.y);
      fracPartX:=(ix+guess.x+v.x)-trunc(ix+guess.x+v.x);
      fracPartY:=(iy+guess.y+v.y)-trunc(iy+guess.y+v.y);
      ImageJR:=(1-fracPartX)*(1-fracPartY)*RMatrixR[extL][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*RMatrixR[extL][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*RMatrixR[extL][intPartX,intPartY+1]
             +fracPartX*fracPartY*RMatrixR[extL][intPartX+1,intPartY+1];
      ImageJG:=(1-fracPartX)*(1-fracPartY)*RMatrixG[extL][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*RMatrixG[extL][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*RMatrixG[extL][intPartX,intPartY+1]
             +fracPartX*fracPartY*RMatrixG[extL][intPartX+1,intPartY+1];
      ImageJB:=(1-fracPartX)*(1-fracPartY)*RMatrixB[extL][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*RMatrixB[extL][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*RMatrixB[extL][intPartX,intPartY+1]
             +fracPartX*fracPartY*RMatrixB[extL][intPartX+1,intPartY+1];

      if (i0-trunc(i0)>0) and (j0-trunc(j0)>0) then
      begin
        intPartX:=trunc(ix);
        intPartY:=trunc(iy);
        fracPartX:=ix-intPartX;
        fracPartY:=iy-intPartY;
        i0R:=(1-fracPartX)*(1-fracPartY)*LMatrixR[extL][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixR[extL][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixR[extL][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixR[extL][intPartX+1,intPartY+1];
        i0G:=(1-fracPartX)*(1-fracPartY)*LMatrixG[extL][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixG[extL][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixG[extL][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixG[extL][intPartX+1,intPartY+1];
        i0B:=(1-fracPartX)*(1-fracPartY)*LMatrixB[extL][intPartX,intPartY]
             +fracPartX*(1-fracPartY)*LMatrixB[extL][intPartX+1,intPartY]
             +(1-fracPartX)*fracPartY*LMatrixB[extL][intPartX,intPartY+1]
             +fracPartX*fracPartY*LMatrixB[extL][intPartX+1,intPartY+1];

        deltaIr:=i0R-ImageJR;
        deltaIg:=i0G-ImageJG;
        deltaIb:=i0B-ImageJB;
      end
      else
      begin
        deltaIr:=LMatrixR[extL][round(ix),trunc(iy)]-ImageJR;
        deltaIb:=LMatrixB[extL][round(ix),trunc(iy)]-ImageJB;
        deltaIg:=LMatrixG[extL][round(ix),trunc(iy)]-ImageJG;
      end;
      MismatchVector.x:=MismatchVector.x+
              deltaIr*dxMatrixR[extL][px,py]+deltaIg*dxMatrixG[extL][px,py]+
              deltaIb*dxMatrixB[extL][px,py];
      MismatchVector.y:=MismatchVector.y+
              deltaIr*dyMatrixR[extL][px,py]+deltaIg*dyMatrixG[extL][px,py]+
              deltaIb*dyMatrixB[extL][px,py];
      iy:=iy+1;
      if extL>0 then py:=py+deg else py:=py+1;
    until iy>=j1;
    ix:=ix+1;
    if extL>0 then px:=px+deg else px:=px+1;
  until ix>=i1;
end;

{-------------    , ""  -------------}
procedure FeatureSelection;
var Discr : real;         //     . 
    k,l,k0,l0,k1,l1 : integer;
begin
//            .
// !!!       -     1   .
 realwx:=1;  realwy:=1;
 MaxEigenValue:=-MaxInt;
 SetLength(U,nx[0],ny[0]);
 SetLength(EigenValues1,nx[0]+1,ny[0]+1);
 SetLength(EigenValues2,nx[0]+1,ny[0]+1);
 extL:=0;
 for i:=5 to nx[0]-6 do  //     1    
 begin
   for j:=5 to ny[0]-6 do
   begin
      i0:=i-1;
      j0:=j-1;
      i1:=i+1;
      j1:=j+1;
      BuildGradientMatrix(i,j);

      //   G.    .
      Discr:=sqrt((G[1,1]+G[2,2])*(G[1,1]+G[2,2])-4*(G[1,1]*G[2,2]-G[1,2]*G[2,1]));
      if Discr>=0 then begin
                        EigenValues1[i,j]:=((G[1,1]+G[2,2])+Discr)/2;
                        EigenValues2[i,j]:=((G[1,1]+G[2,2])-Discr)/2 // .  
                       end
        else EigenValues2[i,j]:=-MaxInt;
  //    EigenValues2[i,j]:=EigenValues2[i,j]/((realwx*2+1)*(realwy*2+1));
      if EigenValues2[i,j]>MaxEigenValue then MaxEigenValue:=EigenValues2[i,j];

    //      .
   end; // j
 end;   // i

 //       .
 for i:=5 to nx[0]-6 do
 begin
   for j:=5 to ny[0]-6 do
   begin
     if (EigenValues2[i,j]>NMax) and
      (EigenValues2[i,j]>EigenValues2[i-1,j]) and (EigenValues2[i,j]>EigenValues2[i+1,j])
       and (EigenValues2[i,j]>EigenValues2[i,j-1]) and (EigenValues2[i,j]>EigenValues2[i+1,j+1])
        and (EigenValues2[i,j]>EigenValues2[i-1,j-1]) and (EigenValues2[i,j]>EigenValues2[i-1,j+1])
         and (EigenValues2[i,j]>EigenValues2[i+1,j-1]) and (EigenValues2[i,j]>EigenValues2[i+1,j+1])
      then U[i,j]:=true
       else U[i,j]:=false;

      if i>10 then k0:=i-10 else k0:=2;
      if j>10 then l0:=j-10 else l0:=2;
      if i<nx[0]-12 then k1:=i+10 else k1:=nx[0]-2;
      if j<ny[0]-12 then l1:=j+10 else l1:=ny[0]-2;
      for k:=k0 to k1 do
      begin
        for l:=l0 to l1 do
          if (((k<>i) or (l<>j)) and (U[k,l]=true)) then U[i,j]:=false;
      end;
      if U[i,j] then SpecialPtBitMap.Canvas.Pixels[i,j]:=clBlue;
    end;
 end;
 SpecialPtBitMap.SaveToFile('special_points.bmp');
{    U - ,   0  1
  0 -         
  1 -           }
end;

{*********************    ********************************}
begin
  ReadParameters;
  writeln('Start image processing...');
  try
   //     
    BitMapLeft:=TBitmap.Create;
    BitMapLeft.LoadFromFile(PathToFiles+'\'+FileName+'.bmp');
    BitMapRight:=TBitmap.Create;
    i:=StrToInt(FileName);
    Inc(i);
    FileName:=IntToStr(i);
    BitMapRight.LoadFromFile(PathToFiles+'\'+FileName+'.bmp');
  except
  end;
  nx[0]:=BitMapLeft.Width;
  ny[0]:=BitMapLeft.Height;

 //     (R,G,B)   

 SetLength(LMatrixR[0],nx[0]+2,ny[0]+2);
 SetLength(LMatrixG[0],nx[0]+2,ny[0]+2);
 SetLength(LMatrixB[0],nx[0]+2,ny[0]+2);
 SetLength(RMatrixR[0],nx[0]+2,ny[0]+2);
 SetLength(RMatrixG[0],nx[0]+2,ny[0]+2);
 SetLength(RMatrixB[0],nx[0]+2,ny[0]+2);
 for i:=1 to nx[0] do
 begin
   for j:=1 to ny[0] do
   begin
     pxl:=BitmapLeft.Canvas.Pixels[i,j];
     newColor:=DecomposeColor(pxl);
     LMatrixR[0][i,j]:=newColor.r;
     LMatrixG[0][i,j]:=newColor.b;
     LMatrixB[0][i,j]:=newColor.g;
     if i=1 then LMatrixR[0][0,j]:=LMatrixR[0][1,j];
     if i=1 then LMatrixG[0][0,j]:=LMatrixG[0][1,j];
     if i=1 then LMatrixB[0][0,j]:=LMatrixB[0][1,j];
     if i=nx[0] then LMatrixR[0][nx[0]+1,j]:=LMatrixR[0][nx[0],j];
     if i=nx[0] then LMatrixG[0][nx[0]+1,j]:=LMatrixG[0][nx[0],j];
     if i=nx[0] then LMatrixB[0][nx[0]+1,j]:=LMatrixB[0][nx[0],j];

     pxl:=BitmapRight.Canvas.Pixels[i,j];
     newColor:=DecomposeColor(pxl);
     RMatrixR[0][i,j]:=newColor.r;
     RMatrixG[0][i,j]:=newColor.b;
     RMatrixB[0][i,j]:=newColor.g;
     if i=1 then RMatrixR[0][0,j]:=RMatrixR[0][1,j];
     if i=1 then RMatrixG[0][0,j]:=RMatrixG[0][1,j];
     if i=1 then RMatrixB[0][0,j]:=RMatrixB[0][1,j];
     if i=nx[0] then RMatrixR[0][nx[0]+1,j]:=RMatrixR[0][nx[0],j];
     if i=nx[0] then RMatrixG[0][nx[0]+1,j]:=RMatrixG[0][nx[0],j];
     if i=nx[0] then RMatrixB[0][nx[0]+1,j]:=RMatrixB[0][nx[0],j];
   end;
   LMatrixR[0][i,0]:=LMatrixR[0][i,1];
   LMatrixG[0][i,0]:=LMatrixG[0][i,1];
   LMatrixB[0][i,0]:=LMatrixB[0][i,1];
   LMatrixR[0][i,ny[0]+1]:=LMatrixR[0][i,ny[0]];
   LMatrixG[0][i,ny[0]+1]:=LMatrixG[0][i,ny[0]];
   LMatrixB[0][i,ny[0]+1]:=LMatrixB[0][i,ny[0]];

   RMatrixR[0][i,0]:=RMatrixR[0][i,1];
   RMatrixG[0][i,0]:=RMatrixG[0][i,1];
   RMatrixB[0][i,0]:=RMatrixB[0][i,1];
   RMatrixR[0][i,ny[0]+1]:=LMatrixR[0][i,ny[0]];
   RMatrixG[0][i,ny[0]+1]:=RMatrixG[0][i,ny[0]];
   RMatrixB[0][i,ny[0]+1]:=RMatrixB[0][i,ny[0]];
 end;

  //          1,...,Lmax.
 writeln('Done');
 writeln('Calculate pyramide levels...');
 for i:=1 to Lmax do
 begin
   nx[i]:=trunc((nx[i-1]+1)/2);
   ny[i]:=trunc((ny[i-1]+1)/2);
   SetLength(LMatrixR[i],nx[i]+2,ny[i]+2);
   SetLength(LMatrixG[i],nx[i]+2,ny[i]+2);
   SetLength(LMatrixB[i],nx[i]+2,ny[i]+2);
   SetLength(RMatrixR[i],nx[i]+2,ny[i]+2);
   SetLength(RMatrixG[i],nx[i]+2,ny[i]+2);
   SetLength(RMatrixB[i],nx[i]+2,ny[i]+2);
   CalculateLDegree('left',i-1);
   CalculateLDegree('right',i-1);
 end;
  CalculateDerivatives;  //       

  SpecialPtBitMap:=TBitMap.Create;
  SpecialPtBitMap.Assign(BitMapLeft);
  writeln('Done');
  writeln('Looking for points "good to track"...');
  FeatureSelection;               //   , ""  

 //      
 dataDir:=GetCurrentDir;
 AssignFile(features,dataDir+'\features.txt'); //  
 Rewrite(features);
 writeln(features, '   L: '+FloatToStr(MaxEigenValue));
 writeln(features,' L*NMax%: '+FloatToStr(Nmax*MaxEigenValue/100));
 writeln(features, 'i       j        L1/N         ');

 AssignFile(false_features,dataDir+'\false_features.txt'); //   
 Rewrite(false_features);
 writeln(false_features, '   L: '+FloatToStr(MaxEigenValue));
 writeln(false_features, 'i       j     L1/N      ');

  DiffBitMap:=TBitMap.Create;
  DiffBitMap.Assign(BitMapLeft);
  writeln('Done');
  writeln('Tracking corresponding points...');
  //         
  //    px-wx  px+wx
  SetLength(ImR,2*wx+3,2*wy+3);
  SetLength(ImG,2*wx+3,2*wy+3);
  SetLength(ImB,2*wx+3,2*wy+3);
  FeaturesQuant:=0;
  False_FeaturesQuant:=0;
  Lost_FeaturesQuant:=0;
  for i:=2 to nx[0]-1 do
  begin
   for j:=2 to ny[0]-1 do
   begin
     if U[i,j] then
     begin
     guess.x:=0;    //      .
     guess.y:=0;
     PointIsLost:=false;
     for extL:=Lmax downto 0 do  //   
     begin
       if not(PointIsLost) then
       begin
         deg:=1;
         for l:=1 to extL do
          deg:=deg*2;
         uL.x:=i/deg;            //    U   extL
         uL.y:=j/deg;
         CalcBoundaries(uL.x,uL.y);
         BuildGradientMatrix(uL.x, uL.y);
         determinant:=G[1,1]*G[2,2]-G[1,2]*G[2,1];
         v.x:=0;
         v.y:=0;
         if determinant<>0 then
         begin
            inverseG[1,1]:=G[2,2]/determinant;
            inverseG[1,2]:=-G[1,2]/determinant;
            inverseG[2,1]:=-G[2,1]/determinant;
            inverseG[2,2]:=G[1,1]/determinant;
            IntL:=0;
            repeat
              Inc(IntL);
              if (i1+guess.x+v.x<=nx[extL]) and (j1+guess.y+v.y<ny[extL])
               and (i0+guess.x+v.x>0) and (j0+guess.y+v.y>0)
               then BuildImageMismatchVector(uL.x, uL.y)
                 else PointIsLost:=true;    //  
              v.x:=v.x+inverseG[1,1]*MismatchVector.x+inverseG[1,2]*MismatchVector.y;
              v.y:=v.y+inverseG[2,1]*MismatchVector.x+inverseG[2,2]*MismatchVector.y;
            until (abs(v.x)<0.05) and (abs(v.y)<0.05) or (IntL>=10) or (PointIsLost);
          if extL>0 then
          begin
            guess.x:=2*(guess.x+v.x);
            guess.y:=2*(guess.y+v.y);
          end;
         end;  //  determinant<>0
       end;   // if not(PointIsLost)
       end;   // extL

       if not(PointIsLost) and (i1+guess.x+v.x<=nx[0]) and (j1+guess.y+v.y<ny[0])
         and (i0+guess.x+v.x>0) and (j0+guess.y+v.y>0) then
       begin
         tempResultX:=i+round(guess.x+v.x);
         tempResultY:=j+round(guess.y+v.y);
         strX:=FloatToStr(tempResultX);
         strY:=FloatToStr(tempResultY);
         repeat
          strX:=strX+' ';
         until length(strX)>=5;
         repeat
          strY:=strY+' ';
         until length(strY)>=5;
         DiffSum:=0;
         for i2:=i-wx to i+wx do
         begin
            for j2:=j-wy to j+wy do
            begin
              tempResultX:=i2+round(guess.x+v.x);
              tempResultY:=j2+round(guess.y+v.y);
              diffColor.r:=round(abs(LMatrixR[0][i2,j2]-RMatrixR[0][tempResultX,tempResultY]));
              diffColor.g:=round(abs(LMatrixG[0][i2,j2]-RMatrixG[0][tempResultX,tempResultY]));
              diffColor.b:=round(abs(LMatrixB[0][i2,j2]-RMatrixB[0][tempResultX,tempResultY]));
              DiffSum:=DiffSum+sqrt(diffColor.r*diffColor.r+diffColor.g*diffColor.g+diffColor.b*diffColor.b);
            end;
         end;
         DiffSum:=DiffSum/((wx*2+1)*(wy*2+1));
         str:='('+IntToStr(diffColor.r)+','+IntToStr(diffColor.g)+','+IntToStr(diffColor.b)+')';
         if DiffSum<=25 then //   ""
         begin
          writeln(features,IntToStr(i)+'      '+IntToStr(j)+'      '
            +IntToStr(round(EigenValues2[i,j]))
             +'      '+IntToStr(round(DiffSum)));
          Inc(FeaturesQuant);
         end
         else                          //  ,   ""
         begin
         writeln(False_features,IntToStr(i)+'      '+IntToStr(j)+'      '
            +IntToStr(round(EigenValues2[i,j]))
             +'      '+IntToStr(round(DiffSum)));
          Inc(False_FeaturesQuant);
         end;
         DiffBitMap.Canvas.Pixels[i,j]:=RGB(diffColor.r,diffColor.g,diffColor.b);
       end
       else begin             //   
              strX:='lost ';
              strY:='lost ';
              str:='    lost    ';
              DiffBitMap.Canvas.Pixels[i,j]:=clRed;
          {    writeln(false_features,IntToStr(i)+'      '+IntToStr(j)+'      '
               //IntToStr(round(EigenValues1[i,j]))+'      '
                 +IntToStr(round(EigenValues2[i,j])));
              Inc(False_FeaturesQuant);}
              Inc(Lost_FeaturesQuant);
            end;
   { ,     (i,j)     
  ResultU[i,j]   . }
    end // U[i,j]=true
    else DiffBitMap.Canvas.Pixels[i,j]:=clWhite;
    end; // j
  end;  // i
  writeln('Done');
  writeln('Saving results...');
  writeln(features,'');
  writeln(features, '  : '+IntToStr(FeaturesQuant));
  CloseFile(features);
  writeln(false_features,'');
  writeln(false_features, '  : '+IntToStr(FeaturesQuant));
  writeln(false_features, '  : '+IntToStr(False_FeaturesQuant));
  writeln(false_features, '  : '+IntToStr(Lost_FeaturesQuant));
  writeln(false_features,' -   -   '+
                 FloatToStr(FeaturesQuant/False_FeaturesQuant));
  CloseFile(false_features);
  DiffBitMap.SaveToFile('difference.bmp');
  writeln('Done');
end.
